/****************************************************************************
**
** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
** All rights reserved.
** Contact: Nokia Corporation (qt-info@nokia.com)
**
** This file is part of the QtDeclarative module of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:LGPL$
** No Commercial Usage
** This file contains pre-release code and may not be distributed.
** You may use this file in accordance with the terms and conditions
** contained in the Technology Preview License Agreement accompanying
** this package.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU Lesser General Public License version 2.1 requirements
** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Nokia gives you certain additional
** rights.  These rights are described in the Nokia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** If you have questions regarding the use of this file, please contact
** Nokia at qt-info@nokia.com.
**
**
**
**
**
**
**
**
** $QT_END_LICENSE$
**
****************************************************************************/

#ifndef QMLPACKAGE_H
#define QMLPACKAGE_H

#include <qml.h>

QT_BEGIN_HEADER

QT_BEGIN_NAMESPACE

QT_MODULE(Declarative)

/*****************************************************************************
 *****************************************************************************
 XXX Experimental
 *****************************************************************************
*****************************************************************************/

class QmlPackagePrivate;
class QmlPackageAttached;
class QmlPackage : public QObject
{
    Q_OBJECT
    Q_DECLARE_PRIVATE(QmlPackage)

    Q_CLASSINFO("DefaultProperty", "data")
    Q_PROPERTY(QmlList<QObject *> *data READ data SCRIPTABLE false)

public:
    QmlPackage(QObject *parent=0);
    virtual ~QmlPackage();

    QmlList<QObject *> *data();

    QObject *part(const QString & = QString());
    bool hasPart(const QString &);

    static QmlPackageAttached *qmlAttachedProperties(QObject *);
};

QT_END_NAMESPACE

QML_DECLARE_TYPE(QmlPackage)
QML_DECLARE_TYPEINFO(QmlPackage, QML_HAS_ATTACHED_PROPERTIES)

QT_END_HEADER

#endif // QMLPACKAGE_H
