/****************************************************************************
**
** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
** All rights reserved.
** Contact: Nokia Corporation (qt-info@nokia.com)
**
** This file is part of the Qt QML Debugger of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:LGPL$
** No Commercial Usage
** This file contains pre-release code and may not be distributed.
** You may use this file in accordance with the terms and conditions
** contained in the Technology Preview License Agreement accompanying
** this package.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU Lesser General Public License version 2.1 requirements
** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Nokia gives you certain additional
** rights.  These rights are described in the Nokia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** If you have questions regarding the use of this file, please contact
** Nokia at qt-info@nokia.com.
**
**
**
**
**
**
**
**
** $QT_END_LICENSE$
**
****************************************************************************/
#ifndef CANVASFRAMERATE_H
#define CANVASFRAMERATE_H

#include <QtCore/qpointer.h>
#include <QtGui/qwidget.h>

#include <private/qmldebugclient_p.h>

QT_BEGIN_NAMESPACE

class QTabWidget;
class QSlider;
class QGroupBox;
class QLabel;
class QSpinBox;
class QPushButton;

class CanvasFrameRatePlugin;

class CanvasFrameRate : public QWidget
{
    Q_OBJECT
public:
    CanvasFrameRate(QWidget *parent = 0);
    
    void reset(QmlDebugConnection *conn);

    void setSizeHint(const QSize &);
    virtual QSize sizeHint() const;

private slots:
    void clearGraph();
    void newTab();
    void enabledToggled(bool);
    void connectionStateChanged(QAbstractSocket::SocketState state);

private:
    void handleConnected(QmlDebugConnection *conn);

    QGroupBox *m_group;
    QTabWidget *m_tabs;
    QSpinBox *m_res;
    QPushButton *m_clearButton;
    CanvasFrameRatePlugin *m_plugin;
    QSize m_sizeHint;
};

QT_END_NAMESPACE

#endif // CANVASFRAMERATE_H

